%
function [Pinj_t , SOC_t , Pcharge_t, Pdcharge_t , line_flow_ampl_t , teta_t] = fun_VEL_runMPC_Bat_CDC_T2( ps , Soc0 , SocMax , Pload , Pinj_set , PchargeMax , seg, Pvpp , PG0, B )
nl = size(ps.branch,1);
nb = size(ps.bus,1);

M = size(Pload,2);
Time = [1:1:M];

%B = imag(makeYbus(ps.baseMVA,ps.bus , ps.branch));
%SocMax  = SocMax;
%SocInit = Soc0;

gen_data = sortrows(ps.gen);
genNum = unique(gen_data(:,1));
PgenMax  = zeros(nb,1);
PgenRamp = zeros(nb,1);
PgenMax(genNum) = 1*ps.gen(:,9);
PgenRamp(genNum) = 1*ps.gen(:,9)*(1/seg);
%PgenRamp(37) = 1000*PgenRamp(37); %Relaxing ramp rate for tie line!

gen_cost = ones(nb,M);


%% AMPL

ModelDirectory = fileparts(which('ampl_test2.m'))

setupOnce
ampl = AMPL;
%ampl.read(['/Users/Mahraz/Dropbox/new/MPC/try5/AMPLEX/VEL_MPC_Bat_CDC_T2.mod'])
ampl.read([ModelDirectory , '/' , 'MPC39.mod'])
ampl.getSet('BUS').setValues(ps.bus(:,1));
BRANCH = ampl.getSet('BRANCH');
BRANCH.setValues( [(1:1:nl)' ps.branch(:,(1:2))]);


ampl.getSet('Time').setValues(Time');

ampl.getParameter('bus_type').setValues(ps.bus(:,2));
ampl.getParameter('bus_p_load_test').setValues(Pload/ps.baseMVA);
ampl.getParameter('bus_gen_cost').setValues(gen_cost);
ampl.getParameter('bus_p_gen_max').setValues(PgenMax/ps.baseMVA);
ampl.getParameter('bus_Gen_ramp').setValues(PgenRamp/ps.baseMVA);

ll = ps.branch(:,6)/ps.baseMVA;

ampl.getParameter('line_limit').setValues(ll);
ampl.getParameter('B').setValues(B);
ampl.getParameter('bus_p_inj_set').setValues(Pinj_set);


ampl.getParameter('SocMax').setValues(SocMax);
ampl.getParameter('SocInit').setValues(Soc0);
ampl.getParameter('PchargeMax').setValues(PchargeMax);
ampl.getParameter('PchargeRate').setValues(PchargeMax/5); % the VPP can reach its maximum charging in 5 minutes
ampl.getParameter('PCDC0').setValues(Pvpp);
ampl.getParameter('PG0').setValues(PG0);




%ampl.readData(['/Users/Mahraz/Dropbox/new/MPC/try4/MPCd.dat'])
ampl.readData([ModelDirectory , '/' ,'MPCd39.dat'])

ampl.eval('option solver gurobi ;');         % solver ipopt
ampl.solve();
ampl.eval('display solve_message;');
ampl.eval('display  solve_result;');
%ampl.eval('for {p in Time} { display p,{k in BUS : bus_type[k]==2||bus_type[k]==3} bus_p_inj[k,p]  , {k in BUS} bus_angle[k,p]};')

Pinj   = ampl.getVariable('bus_p_inj').getValues.getColumnAsDoubles('val');
Pinj_t = reshape(Pinj , M, [])';  % now each col corresponds one time step

SOC = ampl.getVariable('SOC').getValues.getColumnAsDoubles('val');
SOC_t = reshape(SOC , M, [])';

Pcharge   = ampl.getVariable('Pcharge').getValues.getColumnAsDoubles('val');
Pcharge_t = reshape(Pcharge , M , [])';
Pdcharge   = ampl.getVariable('Pdcharge').getValues.getColumnAsDoubles('val');
Pdcharge_t = reshape(Pdcharge , M , [])';

line_flow_ampl = ampl.getVariable('line_flow').getValues.getColumnAsDoubles('val');
line_flow_ampl_t = reshape(line_flow_ampl , M , [])';

teta = ampl.getVariable('bus_angle').getValues.getColumnAsDoubles('val');
teta_t =  reshape(teta , M , [])';
%ampl.eval('display {(l,k,m) in BRANCH , p in Time : p == 1} line_flow[l,k,m,p];')

ampl.display('bus_p_gen_max;')
ampl.display('bus_p_inj;')
%ampl.display('PG0;')
%ampl.display('bus_Gen_ramp;')
%ampl.eval('expand generator_ramp_limit0;')
ampl.eval('expand p_inj;')


ampl.close();


